/***********************************************************************************************/
/* Main IceTheme template Scripts */
/***********************************************************************************************/


/* default joomla script */
(function($)
{
	$(document).ready(function()
	{
		$('*[rel=tooltip]').tooltip()

		// Turn radios into btn-group
		$('.radio.btn-group label').addClass('btn');
		$(".btn-group label:not(.active)").click(function()
		{
			var label = $(this);
			var input = $('#' + label.attr('for'));

			if (!input.prop('checked')) {
				label.closest('.btn-group').find("label").removeClass('active btn-success btn-danger btn-primary');
				if (input.val() == '') {
					label.addClass('active btn-primary');
				} else if (input.val() == 0) {
					label.addClass('active btn-danger');
				} else {
					label.addClass('active btn-success');
				}
				input.prop('checked', true);
			}
		});
		$(".btn-group input[checked=checked]").each(function()
		{
			if ($(this).val() == '') {
				$("label[for=" + $(this).attr('id') + "]").addClass('active btn-primary');
			} else if ($(this).val() == 0) {
				$("label[for=" + $(this).attr('id') + "]").addClass('active btn-danger');
			} else {
				$("label[for=" + $(this).attr('id') + "]").addClass('active btn-success');
			}
		});
	})
})(jQuery);



/* jQuery scripts for IceTheme template */
jQuery(document).ready(function() {  

	// check if agent its an apple product
	var device = navigator.userAgent.toLowerCase();
	var ios = device.match(/(iphone|ipod|ipad)/);
	if (ios) {
		//ADD CLASSES HERE THAT WILL ONLY APPLY TO IOS
		jQuery("body").addClass("ios-browser");
	} 

	// Responsive Tables JQuery 
	//http://zurb.com/playground/playground/responsive-tables/index.html
	var switched = false;
	var updateTables = function() {
	if ((jQuery(window).width() < 979) && !switched ){
	  switched = true;
	  jQuery("table.responsive").each(function(i, element) {
		splitTable(jQuery(element));
	  });
	  return true;
	}
	else if (switched && (jQuery(window).width() > 979)) {
	  switched = false;
	  jQuery("table.responsive").each(function(i, element) {
		unsplitTable(jQuery(element));
	  });
	}
	};
	
	jQuery(window).load(updateTables);
	jQuery(window).bind("resize", updateTables);
	
	
	function splitTable(original)
	{
		original.wrap("<div class='table-wrapper' />");
		
		var copy = original.clone();
		copy.find("td:not(:first-child), th:not(:first-child)").css("display", "none");
		copy.removeClass("responsive");
		
		original.closest(".table-wrapper").append(copy);
		copy.wrap("<div class='pinned' />");
		original.wrap("<div class='scrollable' />");
	}
	
	function unsplitTable(original) {
	original.closest(".table-wrapper").find(".pinned").remove();
	original.unwrap();
	original.unwrap();
	}


	// Go to Top Link
	 jQuery(window).scroll(function(){
		if ( jQuery(this).scrollTop() > 1000) {
			 jQuery("#gotop").addClass("gotop_active");
		} else {
			 jQuery("#gotop").removeClass("gotop_active");
		}
	}); 
	jQuery(".scrollup").click(function(){
		jQuery("html, body").animate({ scrollTop: 0 }, 600);
		return false;
	});


	/* initialize bootstrap tooltips */
	jQuery("[rel='tooltip']").tooltip();
	
	/* initialize bootstrap popopver */
	jQuery("[rel='popover']").popover();
	
	/* language module hover efffect for flags */
	jQuery(".mod-languages").hover(function () {
		jQuery(".mod-languages li").css({opacity : .25});
	  }, 
	  function () {
		jQuery(".mod-languages li").css({ opacity : 1});
	  }
	);	
	
	/* language module remove title attribute from img*/
	jQuery("div.mod-languages img").data("title", jQuery(this).attr("title")).removeAttr("title");
	
	/* social icons effect on hover */
	jQuery(".social_icons").hover(function () {
		jQuery(".social_icons li a").css({opacity : .25});
	  }, 
	  function () {
		jQuery(".social_icons li a").css({ opacity : 1});
	  }
	);
	
	/* brands icons effect on hover */
	jQuery("ul.icemarquee").hover(function () {
		jQuery("ul.icemarquee li").css({opacity : .25});
	  }, 
	  function () {
		jQuery("ul.icemarquee li").css({ opacity : 1});
	  }
	);
	
	/* add a class to icemegamenu module element */
	jQuery(".ice-megamenu-toggle a").attr("href", "#mainmenu")
	
	/* fade slideshow with white bg on menu hover  */
	jQuery("#mainmenu").hover(function(){     
		jQuery("#iceslideshow > div > div:first-child").addClass("icemegamenu-hover");    
	},     
	function(){    
	   jQuery("#iceslideshow > div > div:first-child").removeClass("icemegamenu-hover");     
	});
	
	/* adjust the search module */
    jQuery("#search form .inputbox").attr('maxlength','35');
	
	/* fix some classes on the content voting */
	jQuery("span.content_vote .btn").removeClass("btn-mini");
	
	/* fix breadcrumbs */
	jQuery("ul.breadcrumb .divider.icon-location").removeClass("divider icon-location");
	
	
	
	/* Some fixes for the Exp Autos Pro Component 
	   Note: You may remove the codes below if you dont plan to use this component
	*/
	jQuery(".expautos_detail_left .nav.nav-tabs li:first-child").addClass("active");
	jQuery(".expautos_detail_left .tab-content div:first-child").addClass("active");
	
	jQuery("#expautos_dealerdetail .nav.nav-tabs li:first-child").addClass("active");
	jQuery("#expautos_dealerdetail .tab-content div:first-child").addClass("active");
	 
	jQuery(".explist_table").addClass("responsive");
	
	
	/* JOOMLA 2.5 adjustments only 
	*/
	jQuery(".button").addClass("btn");
	jQuery("ul.menu").addClass("nav");
	
	
});  


	
// detect if screen is with touch or not (pure JS)
if (("ontouchstart" in document.documentElement)) {
	document.documentElement.className += "with-touch";
}else {
	document.documentElement.className += "no-touch";
}


					
